/***********************************************************************
 * This program loads a vector and a list with the words in a file, 
 * blah.txt. It sorts both using the default string comparison, and using 
 * a case-insensitive string comparison. 
 *
 * There must be a file blah.txt in the directory for this to work.
 ***********************************************************************/

#include <algorithm>
#include<iostream>
#include <string>
#include <vector>
#include <fstream>
#include <cctype>
#include <list>

using std::cin;		using std::sort;
using std::cout;        using std::list;
using std::endl;	using std::string;
using std::vector;
using std::ifstream;	    
bool alpha_compare(const string& a, const string& b);
void show_string_vec(const vector<string> & v);
void show_string_list(const list<string> & v);
int main()
{
vector<string> words;
list<string> word_list;
string current;
ifstream infile("blah.txt");
if(!infile)
{
	cout<<"Unable to open infile.\n";
	return 1;
}
while(infile>>current)
{
	words.push_back(current);
	word_list.push_back(current);
}
cout<<"Comparing 'Zebra' and 'aardvark' with "
	<<"our case-insensitive comparison gives "
	<<alpha_compare("Zebra","aardvark")<<endl;

cout<<"\nOur text file contains the words \n";
show_string_vec(words);

cout<<"\n\nWhen sorted with the two argument sort, get \n";
sort(words.begin(),words.end());
show_string_vec(words);

word_list.sort();
cout<<endl<<"\nSimilarly for the 0-parameter list sort: \n";
show_string_list(word_list);

cout<<"\n\nSort with three argument sort, and case insensitive comparison:\n";
sort(words.begin(),words.end(), alpha_compare);
show_string_vec(words);

word_list.sort(alpha_compare);
cout<<endl<<"\nSimilarly for the 1-parameter list sort: \n";
show_string_list(word_list);
cout<<endl;


return 0;
	
	
}
bool alpha_compare(const string& a, const string& b)
{
	string a1=a, b1=b;
	for(string::size_type i=0; i!=a.size(); i++)
		a1[i]=tolower(a[i]);
	
	for(string::size_type i=0; i!=b.size(); i++)
		b1[i]=tolower(b[i]);

	return a1<b1;
}

void show_string_vec(const vector<string> & v)
{
	for(vector<string>::size_type i=0; i!=v.size();i++)
cout<<v[i]<<" ";
	return;
}

void show_string_list(const list<string> & L)
{
	for(list<string>::const_iterator it=L.begin();it!=L.end();it++)
		cout<<*it<<" ";
	return;
}
